<?php 
/**
 * Convertidor de bytes - repaso_1.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2011 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2011-11-16
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Convertidor de bytes (Resultado). Repaso 1.
  Ejercicios. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>

<body>
<h1>Convertidor de bytes (Resultado)</h1>
<?php

function recoge($var) 
{
    $tmp = (isset($_REQUEST[$var])) ? strip_tags(trim(htmlspecialchars($_REQUEST[$var]))) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    return $tmp;
}

define('NUM_MAXIMO', 100000000000000);

$bytes   = recoge('bytes');
$bytesOk = FALSE;

if ($bytes=="") {
    print "<p class=\"aviso\">No ha escrito los bytes.</p>\n";
} elseif (!is_numeric($bytes)) { 
    print "<p class=\"aviso\">No ha escrito los bytes como número.</p>\n";
} elseif (!ctype_digit($bytes)) { 
    print "<p class=\"aviso\">No ha escrito los bytes como número entero positivo (sin parte decimal)</p>\n";
} elseif ($bytes>NUM_MAXIMO) {
    print "<p class=\"aviso\">Los bytes deben ser inferiores a "
        .number_format(NUM_MAXIMO, 0, ',', '.').".</p>\n";
    // Es mejor no mostrar NUM_MAXIMO porque si es superior a PHP_INT_MAX se muestra como float
} else {
    $bytesOk = TRUE;
}
    
if ($bytesOk) {
    $gb = bcdiv($bytes, 1024*1024*1024);
    $b  = bcmod($bytes, 1024*1024*1024);
    $mb = bcdiv($b, 1024*1024);
    $b  = bcmod($b, 1024*1024);
    $kb = bcdiv($b, 1024);
    $b  = bcmod($b, 1024);
    
    print "<p>".number_format($bytes, 0, ',', '.')." bytes son ";
    if ($bytes==0) {
    	print "0 bytes.";
    }
    if ($gb) {
        print number_format($gb, 0, ',', '.')." GB";
        if (($mb && $kb) || ($mb && $b)|| ($kb && $b)) {
            print ", ";
        } elseif ($mb || $kb || $b) {
            print " y ";
        }
    }
    if ($mb) {
        print number_format($mb, 0, ',', '.')." MB";
        if ($kb && $b) {
            print ", ";
        } elseif ($kb || $b) {
            print " y ";
        }
    }
    if ($kb) {
        print number_format($kb, 0, ',', '.')." KB";
        if ($b) {
            print " y ";
        }
    }
    if ($b==1) {
        print "1 byte";
    } elseif ($b) {
        print number_format($b, 0, ',', '.')." bytes";
    }
    print ".<p>\n";
}

print "<p><a href=\"repaso_1b.html\">Volver al formulario.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 16 de noviembre de 2011
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
